% picard_a3ExSequence plots a sequence of Ex components
%
% HG 2020-10-02

fontname = 'utopia';

run('inputpicarda3.m')
Nx=Nx_local*iprocs;
Ny=Ny_local*jprocs;
Nz=Nz_local*kprocs;
dxyz=[(xmax-xmin)/Nx (ymax-ymin)/Ny (zmax-zmin)/Nz];
xcorn = xmin + [0:Nx]*dxyz(1); x = 0.5*(xcorn(1:end-1)+xcorn(2:end));
ycorn = ymin + [0:Ny]*dxyz(2); y = 0.5*(ycorn(1:end-1)+ycorn(2:end));
zcorn = zmin + [0:Nz]*dxyz(3); z = 0.5*(zcorn(1:end-1)+zcorn(2:end));

dd = h5info('outp/Efield.h5');

figure(300)
clf
  fpos = get(gcf,'pos');
set(gcf,'paperpositionmode','auto', ...
        'position',[fpos(1) fpos(2)+fpos(4)-900 1550 900])
clear ha;
cax=zeros(length(dd),2);

for ii=1:length(dd.Groups)
  Ex = h5read('outp/Efield.h5',[dd.Groups(ii).Name '/Ex']);
  ha(ii) = subplot(3,5,ii);
  [a iy0]=min(abs(ycorn-0));
  pp(:,:) = mean(Ex(:,[iy0-1:iy0],:),2);pp=pp.';
  ss=size(pp);
  pp=[[pp zeros(ss(1),1)];zeros(1,ss(2)+1)];
  surf(xcorn,zcorn,pp)
  clear pp
  set(gca,'fontname',fontname,'fontsize',14)
  view(2)
  axis square
  axis([xmin xmax zmin zmax])
  shading flat
  xlabel('x','fontname',fontname,'fontsize',18)
  ylabel('z','fontname',fontname,'fontsize',18)
  title(['iteration=' num2str(str2num(dd.Groups(ii).Name(6:end)))], ...
        'fontname',fontname,'fontsize',14)
  cax(ii,:)=caxis(ha(ii));
end
hapos=get(ha,'position');
caxmin=min(cax(:,1));
caxmax=max(cax(:,2));
for ii=1:length(dd);
  caxis(ha(ii),[caxmin caxmax])
end

% subplot placement assumes there are 15 saved timesteps
for jj=1:3
  for ii=1:5
    splno=(jj-1)*5+ii; % subplot number
    set(ha(splno),'position', ...
                  [(0.06+(ii-1)*0.185) (0.08+(3-jj)*0.33) hapos{splno}(3:4)])
  end
end
hcol=colorbar(ha(end));
set(hcol,'position',[0.94 0.1 0.02 0.85])




if 3==4
  h=get(0,'children')
  ccc = pwd;
  cd ~
  for ii =1:length(h)
    filename = ['fig' num2str(ii,'%0.2d') '.png'];
    print(h(ii),'-r600','-dpng',filename)
  end
  cd(ccc)
end
